/**
 *  Copyright © 2025, Luis Andrés Lange <https://javacomm.net>
 *
 *  Previously released under Apache License 2.0; now licensed under MPL 2.0.
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;



public class CONFERENCEAUDIO extends MESSAGE {

  // SOURCE steht vor websocketSession
  public final static String SOURCE = "SOURCE";
  public final static String CONTENT = "CONTENT";
  public final static String STREAM_ID = "STREAM_ID";
  public final static String AUDIOKEY = "AUDIOKEY";

  private String websocketSession; // der Absender, diese WebsocketSession darf nicht beim Empfänger ankommen
  private byte[] content; // inhalt ist binary kodiert
  private String streamId;
  private String audiokey;

  public CONFERENCEAUDIO() {
    super();
  }



  /**
   * Gib den ConferenceKey zurück.
   * 
   * @return dieser ConferenceKey
   */
  public String getAudiokey() {
    return audiokey;
  }



  public byte[] getContent() {
    return content;
  }



  public String getStreamId() {
    return streamId;
  }



  /**
   * Wer hat die Nachricht gesendet?
   * 
   * @return dieser Anwender
   */
  public String getWebsocketSession() {
    return websocketSession;
  }



  /**
   * Der ConferenceKey ist ein Pflichtattribut. Er ist eine 36-stellige UUIDv4.
   * 
   * @param conferencekey
   *                      dieser ConferenceKey
   */
  public void setAudiokey(String conferencekey) {
    this.audiokey = conferencekey;
  }



  public void setContent(byte[] content) {
    this.content = content;
  }



  public void setStreamId(String streamId) {
    this.streamId = streamId;
  }



  /**
   * Der Absender.
   * 
   * @param userid
   *               dieser Anwender
   */
  public void setWebsocketSession(String userid) {
    websocketSession = userid;
  }



  @Override
  public String toString() {
    GsonBuilder builder = new GsonBuilder();
    Gson gson = builder.create();
    return gson.toJson(this);
  }
}
